(function($) {
	
	
	// 阅读测试文章部分
	$.fn.readingContent = function(option) {
		return this.each(function(i) {
			var rc = new ReadingContent(this, option);
			$(this).data("rc", rc);
		});
	}
	
	var ReadingContent = function(container, option) {
		var defaultOption = {};
		
		this.container = container;
		this.newOption = $.extend({}, defaultOption, option || {});
		
		var content = $("<div class='reading-content'></div>");
		$(this.container).append(content);
		
		this.init = function(data, isOnline, root) {
			var contentData = data;
			
			var regExp = /\<img\>.*?\<img\>/g;
			var imgs = data.match(regExp);
			if (!isOnline) {
				contentData = data.replace(/\n/g, "<br />");
				if (!imgs) {
					imgs = [];
				}
				for (var i = 0; i < imgs.length; i++) {
					var matchstr = imgs[i];
					var imgname = matchstr.substring(5, matchstr.length - 5);
					var replacestr = "<img src='" + root + imgname + "' class='reading-content-image' />";
					contentData = contentData.replace(matchstr, replacestr);
				}
			}
			content.html(contentData);
		}
		
		this.appendTo = function(id) {
			$("#" + id).append(content);
		}
	}
	
	
	
	// 阅读测试题目部分
	$.fn.readingExam = function(option) {
		return this.each(function(i) {
			var re = new ReadingExam(this, option);
			$(this).data("re", re);
		});
	}
	
	var ReadingExam = function(container, option) {
		var defaultOption = {};
		
		this.container = container;
		this.newOption = $.extend({}, defaultOption, option || {});
		
		this.examId;
		this.examName;
		this.examType;
		this.material;
		this.isAnswerCard;
		this.groups;
		this.rootPath;
		
		var content = $("<div class='reading-exam'></div>");
		$(this.container).append(content);
		
		this.appendTo = function(id) {
			$("#" + id).append(content);
		}
		
		this.init = function(data, data2, isOnline, root) {
			
			if (isOnline) {
				this.rootPath = "http://exam2.kouyu100.com/";
			} else {
				this.rootPath = root;
			}
			this.parseExamXML(data, data2);
			content.empty();
			this.drawGroup();
		}
		
		this.parseExamXML = function(data, data2) {
			this.examId = $(data).find("examId").text();
			this.examName = $(data).find("examName").text();
			this.examType = $(data).find("examType").text();
			this.material = $(data).find("material").text();
			this.isAnswerCard = $(data).find("isAnswerCard").text();
			this.groups = new Array();
			
			var grouplist = $(data).find("group");
			var grouplist2 = $(data2).find("group");
			for (var i = 0; i < grouplist.length; i++) {
				
				var g = grouplist[i];
				var g2 = grouplist2[i];
				
				var group = new ReadingGroup();
				group.id = $(g).children("id").text();
				group.groupType = $(g).children("groupType").text();
				group.groupName = $(g).children("groupName").text().replace(/###/g, "<br>");
				// 如果是图片 从exam.xml取数据 || 否则从exam2.xml中取数据
				var groupDesc = $(g).children("groupDesc").text();
				if (imageORtext(groupDesc) == "image") {
					group.groupDesc = $(g).children("groupDesc").text();
				} else {
					group.groupDesc = $(g2).children("groupDesc").text();
				}
				
				group.isReStart = $(g).children("isReStart").text();
				
				var choose_index = 0;
				
				var blanklist = $(g).find("blank");
				var blanklist2 = $(g2).find("blank");
				for (var j = 0; j < blanklist.length; j++) {
					
					var b = blanklist[j];
					var b2 = blanklist2[j];
					
					var blank = new ReadingBlank();
					blank.examId = this.examId;
					blank.groupId = group.id;
					blank.indexId = (++choose_index);
					blank.id = $(b).children("id").text();
					blank.title = $(b).children("title").text().replace(/###/g, "<br>");
					blank.answer = $(b2).children("answer").text();
					blank.score = $(b2).children("score").text();
					
					group.blanks.push(blank);
				}
				
				var chooselist = $(g).find("choose");
				var chooselist2 = $(g2).find("choose");
				for (var k = 0; k < chooselist.length; k++) {
					
					var c = chooselist[k];
					var c2 = chooselist2[k];
					
					var choose = new ReadingChoose();
					choose.examId = this.examId;
					choose.groupId = group.id;
					choose.indexId = (++choose_index);
					choose.id = $(c).children("id").text();
					choose.title = $(c).children("title").text().replace(/###/g, "<br>");
					choose.item1 = $(c).children("item1").text();
					choose.item2 = $(c).children("item2").text();
					choose.item3 = $(c).children("item3").text();
					choose.item4 = $(c).children("item4").text();
					choose.item5 = $(c).children("item5").text();
					choose.answer = $(c2).children("answer").text();
					choose.score = $(c2).children("score").text();
					
					choose.itemSize = 0;			
					if(choose.item1.length > 0){
						choose.itemSize++;
					}
					if(choose.item2.length > 0){
						choose.itemSize++;
					}
					if(choose.item3.length > 0){
						choose.itemSize++;
					}
					if(choose.item4.length > 0){
						choose.itemSize++;
					}
					if(choose.item5.length > 0){
						choose.itemSize++;
					}
					
					choose.itemType = imageORtext(choose.item1.toLowerCase());
					
					group.chooses.push(choose);
				}
				this.groups.push(group);
			}
		}
		
		this.drawGroup = function() {
			
			var examTitle = "<h2 class='reading-exam-title'>" + this.examName + "</h2>";
			content.append(examTitle);
			
			for (var i = 0; i < this.groups.length; i++) {
				var group = this.groups[i];
				var groupDiv = "<div class='reading-exam-group' id='readingGroup_" + group.id + "'>" + group.groupName + "</div>";
				content.append(groupDiv);
				
				// group.groupDesc 分情况判断显示
				var descType = imageORtext(group.groupDesc.toLowerCase());
				if (descType == "image") {
					var descImage = "<div class='group-desc-image'><img src='" + this.rootPath + group.groupDesc + "' style='max-width:90%'/></div>";
					$("#readingGroup_" + group.id).append(descImage);
				} else if (descType == "text" && group.groupDesc.indexOf("#td#") != -1) {
					var table_str = "";
					var rows = group.groupDesc.split("#br#");
					for (var ii = 0; ii < rows.length; ii++) {
						table_str += "<tr>";
						if (rows[ii].indexOf("#td#") != -1) {
							rows[ii] = rows[ii].split("#td#");
						} else {
							rows[ii] = [rows[ii]];
						}
						for (var j = 0; j < rows[ii].length; j++) {
							table_str += "<td";
							if (rows[ii].length == 1) {
								table_str += " colspan='2' align='center'";
							}
							table_str += (">" + rows[ii][j] + "</td>");
						}
						table_str += "</tr>";
					}
					var descTable = "<table class='group-desc-table'>" + table_str + "</table>";
					$("#readingGroup_" + group.id).append(descTable);
				} else if (descType == "text" && group.groupDesc.indexOf("<br>") != -1) {
					var descText = "<div class='group-desc-text'>" + group.groupDesc + "</div>";
					$("#readingGroup_" + group.id).append(descText);
				}
				
				for (var j = 0; j < group.blanks.length; j++) {
					var blank = group.blanks[j];
					this.drawBlank(blank);
				}
				
				for(var k = 0; k < group.chooses.length; k++){
					var choose = group.chooses[k];
					this.drawChoose(choose);
				}
			}
		}
		
		this.drawBlank = function(blank) {
			var blankDiv = "<div class='reading-exam-blank' id='readingBlank_" + blank.id + "'><span>" + blank.title + "</span><input type='text' score='" + blank.score + "' answer='" + blank.answer + "' /><span class='reading-exam-blank-answer'>&nbsp;答案：" + blank.answer + "</span></div>";
			$("#readingGroup_" + blank.groupId).append(blankDiv);
		}
		
		this.drawChoose = function(choose) {
			if (choose.itemType == "image") {
				this.drawChooseImage(choose);
			} else {
				this.drawChooseText(choose);
			}
		}
		
		this.drawChooseImage = function(choose) {
			var chooseDiv = "<div class='reading-exam-choose' id='readingChoose_"+choose.id+"'><div>" + choose.indexId + "." + choose.title + "</div></div>";
			$("#readingGroup_" + choose.groupId).append(chooseDiv);
			
			var choose_str = "<div class='reading-exam-choose-option'>";
			if(choose.itemSize>0){
				choose_str += "<span class='reading-exam-choose-option-image'><input type='radio' name='readingChooseAnswer_" + choose.id + "' alt='A' answer='" + choose.answer + "' score='" + choose.score + "'>A.<img src='" + this.rootPath + choose.item1 + "' width='100px'/></span>";
			}	
			if(choose.itemSize>1){
				choose_str += "<span class='reading-exam-choose-option-image'><input type='radio' name='readingChooseAnswer_" + choose.id + "' alt='B' answer='" + choose.answer + "' score='" + choose.score + "'>B.<img src='" + this.rootPath + choose.item2 + "' width='100px'/></span>";
			}	
			if(choose.itemSize>2){
				choose_str += "<span class='reading-exam-choose-option-image'><input type='radio' name='readingChooseAnswer_" + choose.id + "' alt='C' answer='" + choose.answer + "' score='" + choose.score + "'>C.<img src='" + this.rootPath + choose.item3 + "' width='100px'/></span>";
			}	
			if(choose.itemSize>3){
				choose_str += "<span class='reading-exam-choose-option-image'><input type='radio' name='readingChooseAnswer_" + choose.id + "' alt='D' answer='" + choose.answer + "' score='" + choose.score + "'>D.<img src='" + this.rootPath + choose.item4 + "' width='100px'/></span>";
			}	
			if(choose.itemSize>4){
				choose_str += "<span class='reading-exam-choose-option-image'><input type='radio' name='readingChooseAnswer_" + choose.id + "' alt='E' answer='" + choose.answer + "' score='" + choose.score + "'>E.<img src='" + this.rootPath + choose.item5 + "' width='100px'/></span>";
			}	
	
			choose_str += "</div>";
			$("#readingChoose_"+choose.id).append(choose_str);
		}
		
		this.drawChooseText = function(choose) {
			var chooseDiv = "<div class='reading-exam-choose' id='readingChoose_"+choose.id+"'><div>" + choose.indexId + "." + choose.title + "</div></div>";
			$("#readingGroup_" + choose.groupId).append(chooseDiv);
			
			var choose_str = "<div class='reading-exam-choose-option'>";
			if(choose.itemSize > 0){
				choose_str += "<div class='reading-exam-choose-option-text'><input type='radio' name='readingChooseAnswer_" + choose.id + "' alt='A' answer='" + choose.answer + "' score='" + choose.score + "'>A."+choose.item1+"</div>";
			}	
			if(choose.itemSize > 1){
				choose_str += "<div class='reading-exam-choose-option-text'><input type='radio' name='readingChooseAnswer_" + choose.id + "' alt='B' answer='" + choose.answer + "' score='" + choose.score + "'>B."+choose.item2+"</div>";
			}	
			if(choose.itemSize>2){
				choose_str += "<div class='reading-exam-choose-option-text'><input type='radio' name='readingChooseAnswer_" + choose.id + "' alt='C' answer='" + choose.answer + "' score='" + choose.score + "'>C."+choose.item3+"</div>";
			}	
			if(choose.itemSize>3){
				choose_str += "<div class='reading-exam-choose-option-text'><input type='radio' name='readingChooseAnswer_" + choose.id + "' alt='D' answer='" + choose.answer + "' score='" + choose.score + "'>D."+choose.item4+"</div>";
			}	
			if(choose.itemSize>4){
				choose_str += "<div class='reading-exam-choose-option-text'><input type='radio' name='readingChooseAnswer_" + choose.id + "' alt='E' answer='" + choose.answer + "' score='" + choose.score + "'>E."+choose.item5+"</div>";
			}
			choose_str += "</div>";
			$("#readingChoose_"+choose.id).append(choose_str);
		}
		
		this.showAnswer = function() {
			var score = 0;
			content.find("input").each(function(i, e) {
				if ($(e).attr("type") == "text") {
					$(e).attr("readonly", "readonly");
					if ($(e).val().toLowerCase() == $(e).attr("answer").toLowerCase()) {
						score += parseInt($(e).attr("score"));
//						$(e).siblings(".reading-exam-blank-answer").html("<img src='../../images/classroom/dui.png' />").show();
						$(e).siblings(".reading-exam-blank-answer").html("<img src='chrome://teacher_tools/content/images/classroom/dui.png' />").show();
					} else {
						$(e).siblings(".reading-exam-blank-answer").show();
					}
				} else if ($(e).attr("type") == "radio") {
					$(e).attr("disabled", "disabled");
					
					if ($(e).prop("checked") == true) {
						if ($(e).attr("alt").toLowerCase() == $(e).attr("answer").toLowerCase()) {
							score += parseInt($(e).attr("score"));
//							$(e).parent().append("<img src='../../images/classroom/dui.png' />");
							$(e).parent().append("<img src='chrome://teacher_tools/content/images/classroom/dui.png' />");
						} else {
//							$(e).parent().append("<img src='../../images/classroom/ch.png' />");
							$(e).parent().append("<img src='chrome://teacher_tools/content/images/classroom/ch.png' />");
						}
					}
					if ($(e).attr("alt").toLowerCase() == $(e).attr("answer").toLowerCase()) {
						$(e).parent().css("color", "red");
						$(e).prop("checked", true);
					}
				}
			});
			return score;
		}
	}
	
	
	var ReadingGroup = function() {
		this.id;
		this.groupType;
		this.groupName;
		this.groupDesc;
		this.isReStart;	
		this.examId;	
		this.chooses = new Array();	
		this.blanks = new Array();
	}
	
	var ReadingChoose = function() {
		this.id;
		this.title;
		this.itemType;
		this.itemSize;
		this.item1;
		this.item2;
		this.item3;
		this.item4;
		this.item5;
		this.indexId;
		this.examId;
		this.groupId;
		this.chooseId;
		this.answer;
		this.score;
	}
	
	var ReadingBlank = function() {
		this.id;
		this.title;
		this.indexId;
		this.examId;
		this.groupId;
		this.answer;
		this.score;
	}
	
	
	function imageORtext(name) {
		var extenname = name.substr(name.length - 4, 4);
		if (extenname == ".jpg" || extenname == ".png" || extenname == ".gif") {
			return "image";
		} else {
			return "text";
		}
	}
	
	
})(jQuery);
